;   sleep 
;      WDT
.device LGT8F328P
;8    
;    17 (PB5)
.include "lgt8f328Pdef.inc"
	
.def temp =r16
.def Razr0 = r17 ; 
.def Razr1 = r18
.def Razr2 = r19 ;
.def count = r20 ;

;============  ============
rjmp RESET ;Reset Handle
.org WDTaddr
rjmp WDT_over ;Watchdog Interrupt Vector Address

;==========  ============

out_com:  ;   count  . 
	lds temp,UCSRA
	sbrs temp,UDRE ;   
	rjmp out_com
	sts UDR,count ;count!!!   temp
ret

; N   T ()  .  F () 
;N = TF/5; 8 , 0,125 c = 200 000, $03 0D 40 
.macro Delay80 ;   80 c  1 
ldi Razr2,@0 ;  
ldi Razr1,@1 ;  
ldi Razr0,@2 ;  
R_sub: 
 subi Razr0,1 
 sbci Razr1,0
 sbci Razr2,0
brcc R_sub
.endm

delay:
	dec Razr0
	brne 	delay 	
ret

WDT_over: ;  Watchdog
 sbi PortB,5 ; 
	inc count ;    
	rcall out_com ;    
  Delay80 $03,$0D,40 ; 0,125   8  
 cbi PortB,5 ; 
reti ;  WDT

Reset:
 ldi temp,low(RAMEND) ;  
 out SPL,temp
ldi temp,high(RAMEND) ;  
 out SPH,temp

;====== Set external quartz 0.4 -32 MHz ======
 	clr temp
	clr Razr0	
	ldi temp, 0x80	;enable external crystal
	lds Razr0, PMCR		
	ori Razr0, 0x04 
	sts PMCR, temp
	sts PMCR, Razr0	
	ser Razr0 ;=$FF
	rcall delay	;waiting for crystal stable 256 clocks

 	clr temp
	clr Razr0	
 	ldi temp, 0x80	;switch to external crystal	
	lds Razr0, PMCR			
	andi Razr0, 0x9f
	ori Razr0, 0x20
	sts PMCR, temp
	sts PMCR, Razr0	
	ser Razr0 ;=$FF
	rcall delay	;waiting for crystal stable  256 clocks

	ldi temp, 0x80			;set to right prescale
	ldi Razr0, 0x20	;0x20 - out system clock to PB0
	sts CLKPR, temp
	sts CLKPR, Razr0
	nop
	nop
	nop	
  ;=====end set quartz ===

ldi temp,0b00000001 ; B  PB0  
out DDRB,temp

;=== UART
	ldi temp,51 ;9600  8  
	sts	UBRRL,temp ;. 
	ldi temp,(1<<RXEN|1<<TXEN)
	sts	UCSRB,temp ;. / 8

;====  Watchdog,  !
 wdr ; WDT
 ;   wdt 32 
 lds temp,PMCR
 ori temp,0x10 ;set WCLKS bit
 ldi Razr0,0x80
 sts PMCR, Razr0
 sts PMCR, temp

; WDT: 
 ldi temp,(1<<WDCE)|(1<<WDE) ;   +  
 sts WDTCSR,temp
 ldi temp, (1<<WDIE)|(1<< WDP2)|(1<<WDP1)
; ,  (WDP3:0 = 0110 =4 ) + 
 sts WDTCSR,temp
	
ldi temp,((1<< SM0)|1<< SM1)|(1<<SE) ; Sleep,  DPS1 = Power-save 
out SMCR,temp

clr count ;      

sei ; 
	
Gcykle: ;  
	sleep ;  
 rjmp Gcykle 







